﻿Public Class clsPvPrnWin32API

    Public m_strProcessor As String = Nothing

    Public Sub New()

    End Sub

    Public Function IsWow64() As Boolean

        If (m_strProcessor Is Nothing) Then
            m_strProcessor = System.Environment.GetEnvironmentVariable("PROCESSOR_ARCHITECTURE")
        End If

        If m_strProcessor = "x86" Then
            Return False
        End If

        Return True

    End Function

    Public Function ConnectPrinter(ByVal nInterface As Integer, ByVal szPortName As String, ByVal nBaudRate As Integer, ByVal nDataBits As Integer, ByVal nParity As Integer, ByVal nStopBits As Integer, ByVal nFlowControl As Integer) As Integer
        If (IsWow64()) Then
            Return ConnectPrinter_x64(nInterface, szPortName, nBaudRate, nDataBits, nParity, nStopBits, nFlowControl)
        Else
            Return ConnectPrinter_x86(nInterface, szPortName, nBaudRate, nDataBits, nParity, nStopBits, nFlowControl)
        End If
    End Function

    Public Function DisconnectPrinter() As Boolean
        If (IsWow64()) Then
            Return DisconnectPrinter_x64()
        Else
            Return DisconnectPrinter_x86()
        End If
    End Function

    Public Function GetPrinterDPI() As Integer
        If (IsWow64()) Then
            Return GetPrinterDPI_x64()
        Else
            Return GetPrinterDPI_x86()
        End If
    End Function

    Public Function Print1DBarcode(ByVal nHorizontalPos As Integer, ByVal nVerticalPos As Integer, ByVal nBarcodeType As Integer, ByVal nNarrowBarWidth As Integer, ByVal nWideBarWidth As Integer, ByVal nBarcodeHeight As Integer, ByVal nRotation As Integer, ByVal nHRI As Integer, ByVal pData As String) As Boolean
        If (IsWow64()) Then
            Return Print1DBarcode_x64(nHorizontalPos, nVerticalPos, nBarcodeType, nNarrowBarWidth, nWideBarWidth, nBarcodeHeight, nRotation, nHRI, pData)
        Else
            Return Print1DBarcode_x86(nHorizontalPos, nVerticalPos, nBarcodeType, nNarrowBarWidth, nWideBarWidth, nBarcodeHeight, nRotation, nHRI, pData)
        End If
    End Function

    Public Function Print1DBarcode(ByVal nHorizontalPos As Integer, ByVal nVerticalPos As Integer, ByVal nBarcodeType As Integer, ByVal nNarrowBarWidth As Integer, ByVal nWideBarWidth As Integer, ByVal nBarcodeHeight As Integer, ByVal nRotation As Integer, ByVal nHRI As Integer, ByVal pData As Byte()) As Boolean
        If (IsWow64()) Then
            Return Print1DBarcode_x64(nHorizontalPos, nVerticalPos, nBarcodeType, nNarrowBarWidth, nWideBarWidth, nBarcodeHeight, nRotation, nHRI, pData)
        Else
            Return Print1DBarcode_x86(nHorizontalPos, nVerticalPos, nBarcodeType, nNarrowBarWidth, nWideBarWidth, nBarcodeHeight, nRotation, nHRI, pData)
        End If
    End Function

    Public Function PrintDeviceFont(ByVal nHorizontalPos As Integer, ByVal nVerticalPos As Integer, ByVal nFontName As Integer, ByVal nHorizontalMulti As Integer, ByVal nVerticalMulti As Integer, ByVal nRotation As Integer, ByVal bBold As Boolean, ByVal szText As String) As Boolean
        If (IsWow64()) Then
            Return PrintDeviceFont_x64(nHorizontalPos, nVerticalPos, nFontName, nHorizontalMulti, nVerticalMulti, nRotation, bBold, szText)
        Else
            Return PrintDeviceFont_x86(nHorizontalPos, nVerticalPos, nFontName, nHorizontalMulti, nVerticalMulti, nRotation, bBold, szText)
        End If
    End Function

    Public Function PrintDeviceFontW(ByVal nCodePage As Integer, ByVal nHorizontalPos As Integer, ByVal nVerticalPos As Integer, ByVal nFontName As Integer, ByVal nHorizontalMulti As Integer, ByVal nVerticalMulti As Integer, ByVal nRotation As Integer, ByVal bBold As Boolean, ByVal szText As String) As Boolean
        If (IsWow64()) Then
            Return PrintDeviceFontW_x64(nCodePage, nHorizontalPos, nVerticalPos, nFontName, nHorizontalMulti, nVerticalMulti, nRotation, bBold, szText)
        Else
            Return PrintDeviceFontW_x86(nCodePage, nHorizontalPos, nVerticalPos, nFontName, nHorizontalMulti, nVerticalMulti, nRotation, bBold, szText)
        End If
    End Function

    Public Function SetConfigOfPrinter(ByVal nSpeed As Integer, ByVal nDensity As Integer, ByVal nOrientation As Integer, ByVal bAutoCut As Boolean, ByVal nCuttingPeriod As Integer, ByVal bBackFeeding As Boolean) As Boolean
        If (IsWow64()) Then
            Return SetConfigOfPrinter_x64(nSpeed, nDensity, nOrientation, bAutoCut, nCuttingPeriod, bBackFeeding)
        Else
            Return SetConfigOfPrinter_x86(nSpeed, nDensity, nOrientation, bAutoCut, nCuttingPeriod, bBackFeeding)
        End If
    End Function

    Public Function Prints(ByVal nLabelSet As Integer, ByVal nCopiesOfEachLabel As Integer) As Boolean
        If (IsWow64()) Then
            Return Prints_x64(nLabelSet, nCopiesOfEachLabel)
        Else
            Return Prints_x86(nLabelSet, nCopiesOfEachLabel)
        End If
    End Function

    Public Function SetPaper(ByVal nHorizontalMagin As Integer, ByVal nVerticalMargin As Integer, ByVal nPaperWidth As Integer, ByVal nPaperLength As Integer, ByVal nMediaType As Integer, ByVal nOffSet As Integer, ByVal nGapLengthORThicknessOfBlackLine As Integer) As Boolean
        If (IsWow64()) Then
            Return SetPaper_x64(nHorizontalMagin, nVerticalMargin, nPaperWidth, nPaperLength, nMediaType, nOffSet, nGapLengthORThicknessOfBlackLine)
        Else
            Return SetPaper_x86(nHorizontalMagin, nVerticalMargin, nPaperWidth, nPaperLength, nMediaType, nOffSet, nGapLengthORThicknessOfBlackLine)
        End If
    End Function

    Public Function SetCharacterset(ByVal nInternationalCharacterSet As Integer, ByVal nCodepage As Integer) As Boolean
        If (IsWow64()) Then
            Return SetCharacterset_x64(nInternationalCharacterSet, nCodepage)
        Else
            Return SetCharacterset_x86(nInternationalCharacterSet, nCodepage)
        End If
    End Function

    Public Function ClearBuffer() As Boolean
        If (IsWow64()) Then
            Return ClearBuffer_x64()
        Else
            Return ClearBuffer_x86()
        End If
    End Function

    Public Function PrintBlock(ByVal nHorizontalStartPos As Integer, ByVal nVerticalStartPos As Integer, ByVal nHorizontalEndPos As Integer, ByVal nVerticalEndPos As Integer, ByVal nOption As Integer, ByVal nThickness As Integer) As Boolean
        If (IsWow64()) Then
            Return PrintBlock_x64(nHorizontalStartPos, nVerticalStartPos, nHorizontalEndPos, nVerticalEndPos, nOption, nThickness)
        Else
            Return PrintBlock_x86(nHorizontalStartPos, nVerticalStartPos, nHorizontalEndPos, nVerticalEndPos, nOption, nThickness)
        End If
    End Function

    Public Function PrintCircle(ByVal nHorizontalStartPos As Integer, ByVal nVerticalStartPos As Integer, ByVal nDiameter As Integer, ByVal nMulti As Integer) As Boolean
        If (IsWow64()) Then
            Return PrintCircle_x64(nHorizontalStartPos, nVerticalStartPos, nDiameter, nMulti)
        Else
            Return PrintCircle_x86(nHorizontalStartPos, nVerticalStartPos, nDiameter, nMulti)
        End If
    End Function

    Public Function PrintDirect(ByVal pDirectData As String, ByVal bAddCrLf As Boolean) As Boolean
        If (IsWow64()) Then
            Return PrintDirect_x64(pDirectData, bAddCrLf)
        Else
            Return PrintDirect_x86(pDirectData, bAddCrLf)
        End If
    End Function

    Public Function PrintTrueFont(ByVal nXPos As Integer, ByVal nYPos As Integer, ByVal strFontName As String, ByVal nFontSize As Integer, ByVal nRotaion As Integer, ByVal bItalic As Boolean, ByVal bBold As Boolean, ByVal bUnderline As Boolean, ByVal strText As String, ByVal bDataCompression As Boolean) As Boolean
        If (IsWow64()) Then
            Return PrintTrueFont_x64(nXPos, nYPos, strFontName, nFontSize, nRotaion, bItalic, bBold, bUnderline, strText, bDataCompression)
        Else
            Return PrintTrueFont_x86(nXPos, nYPos, strFontName, nFontSize, nRotaion, bItalic, bBold, bUnderline, strText, bDataCompression)
        End If
    End Function

    Public Function PrintTrueFontW(ByVal nXPos As Integer, ByVal nYPos As Integer, ByVal strFontName As String, ByVal nFontSize As Integer, ByVal nRotaion As Integer, ByVal bItalic As Boolean, ByVal bBold As Boolean, ByVal bUnderline As Boolean, ByVal strText As String, ByVal bDataCompression As Boolean) As Boolean
        If (IsWow64()) Then
            Return PrintTrueFontW_x64(nXPos, nYPos, strFontName, nFontSize, nRotaion, bItalic, bBold, bUnderline, strText, bDataCompression)
        Else
            Return PrintTrueFontW_x86(nXPos, nYPos, strFontName, nFontSize, nRotaion, bItalic, bBold, bUnderline, strText, bDataCompression)
        End If
    End Function

    Public Function PrintVectorFont(ByVal nXPos As Integer, ByVal nYPos As Integer, ByVal FontSelection As String, ByVal FontWidth As Integer, ByVal FontHeight As Integer, ByVal RightSideCharSpacing As String, ByVal bBold As Boolean, ByVal ReversePrinting As Boolean, ByVal TextStyle As Boolean, ByVal Rotation As Integer, ByVal TextAlignment As String, ByVal TextDirection As Integer, ByVal pData As String) As Boolean
        If (IsWow64()) Then
            Return PrintVectorFont_x64(nXPos, nYPos, FontSelection, FontWidth, FontHeight, RightSideCharSpacing, bBold, ReversePrinting, TextStyle, Rotation, TextAlignment, TextDirection, pData)
        Else
            Return PrintVectorFont_x86(nXPos, nYPos, FontSelection, FontWidth, FontHeight, RightSideCharSpacing, bBold, ReversePrinting, TextStyle, Rotation, TextAlignment, TextDirection, pData)
        End If
    End Function

    Public Function PrintVectorFontW(ByVal nXPos As Integer, ByVal nYPos As Integer, ByVal FontSelection As String, ByVal FontWidth As Integer, ByVal FontHeight As Integer, ByVal RightSideCharSpacing As String, ByVal bBold As Boolean, ByVal ReversePrinting As Boolean, ByVal TextStyle As Boolean, ByVal Rotation As Integer, ByVal TextAlignment As String, ByVal TextDirection As Integer, ByVal pData As String) As Boolean
        If (IsWow64()) Then
            Return PrintVectorFontW_x64(nXPos, nYPos, FontSelection, FontWidth, FontHeight, RightSideCharSpacing, bBold, ReversePrinting, TextStyle, Rotation, TextAlignment, TextDirection, pData)
        Else
            Return PrintVectorFontW_x86(nXPos, nYPos, FontSelection, FontWidth, FontHeight, RightSideCharSpacing, bBold, ReversePrinting, TextStyle, Rotation, TextAlignment, TextDirection, pData)
        End If
    End Function
    Public Function PrintPDF417(ByVal nXPos As Integer, _
                        ByVal nYPos As Integer, _
                        ByVal nMaxRow As Integer, _
                        ByVal nMaxCol As Integer, _
                        ByVal nECLevel As Integer, _
                        ByVal nDataType As Integer, _
                        ByVal bHRI As Boolean, _
                        ByVal nOriginPoint As Integer, _
                        ByVal nModuleWidth As Integer, _
                        ByVal nBarHeight As Integer, _
                        ByVal nRotation As Integer, _
                        ByVal pData As String) _
                        As Boolean
        If IsWow64() = True Then
            Return PrintPDF417_x64(nXPos, nYPos, nMaxRow, nMaxCol, nECLevel, nDataType, bHRI, nOriginPoint, nModuleWidth, nBarHeight, nRotation, pData)
        Else
            Return PrintPDF417_x86(nXPos, nYPos, nMaxRow, nMaxCol, nECLevel, nDataType, bHRI, nOriginPoint, nModuleWidth, nBarHeight, nRotation, pData)
        End If
    End Function

    Public Function PrintQRCode(ByVal nXPos As Integer, ByVal nYPos As Integer, ByVal nModel As Integer, ByVal nECCLevel As Integer, ByVal nSize As Integer, ByVal nRotation As Integer, ByVal pData As String) As Boolean
        If (IsWow64()) Then
            Return PrintQRCode_x64(nXPos, nYPos, nModel, nECCLevel, nSize, nRotation, pData)
        Else
            Return PrintQRCode_x86(nXPos, nYPos, nModel, nECCLevel, nSize, nRotation, pData)
        End If
    End Function
    Public Function PrintDataMatrix(ByVal nXPos As Integer, _
                                    ByVal nYPos As Integer, _
                                    ByVal nSize As Integer, _
                                    ByVal bReverse As Boolean, _
                                    ByVal nRotation As Integer, _
                                    ByVal pData As String) _
                                    As Boolean
        If IsWow64() = True Then
            Return PrintDataMatrix_x64(nXPos, nYPos, nSize, bReverse, nRotation, pData)
        Else
            Return PrintDataMatrix_x86(nXPos, nYPos, nSize, bReverse, nRotation, pData)
        End If
    End Function

    Public Function PrintBitmapFile(ByVal nHorizontalStartPos As Integer, ByVal nVerticalStartPos As Integer, ByVal pBitmapFilename As String, ByVal nDither As Integer, ByVal bDataCompression As Boolean) As Boolean
        If (IsWow64()) Then
            Return PrintBitmapFile_x64(nHorizontalStartPos, nVerticalStartPos, pBitmapFilename, nDither, bDataCompression)
        Else
            Return PrintBitmapFile_x86(nHorizontalStartPos, nVerticalStartPos, pBitmapFilename, nDither, bDataCompression)
        End If
    End Function

    Public Function PrintBitmapFileW(ByVal nHorizontalStartPos As Integer, ByVal nVerticalStartPos As Integer, ByVal pBitmapFilename As String, ByVal nDither As Integer, ByVal bDataCompression As Boolean) As Boolean
        If (IsWow64()) Then
            Return PrintBitmapFileW_x64(nHorizontalStartPos, nVerticalStartPos, pBitmapFilename, nDither, bDataCompression)
        Else
            Return PrintBitmapFileW_x86(nHorizontalStartPos, nVerticalStartPos, pBitmapFilename, nDither, bDataCompression)
        End If
    End Function

    Public Function checkStatus() As Integer
        If (IsWow64()) Then
            Return CheckStatus_x64()
        Else
            Return CheckStatus_x86()
        End If
    End Function

End Class
