﻿
// SampleProgramDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SampleProgram.h"
#include "SampleProgramDlg.h"
#include "SatoLibrary/PvPrnWin32API.h"

#ifdef TARGET_64BIT
#pragma comment(lib, ".\\SatoLibrary\\PvPrnWin32API_x64.lib")
#else
#pragma comment(lib, ".\\SatoLibrary\\PvPrnWin32API.lib")
#endif

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CSampleProgramDlg dialog




CSampleProgramDlg::CSampleProgramDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSampleProgramDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSampleProgramDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_IPADDRESS_LAN, m_Lan_IPAddr);
	DDX_Control(pDX, IDC_COMBO_STOPBITS, m_cmbCOM_Stopbits);
	DDX_Control(pDX, IDC_COMBO_COM_DATABITS, m_cmbCOM_Databits);
	DDX_Control(pDX, IDC_COMBO_COM_BAUDRATE, m_cmbCOM_Baudrate);
	DDX_Control(pDX, IDC_COMBO_COM_PARITY, m_cmbCOM_Parity);
	DDX_Control(pDX, IDC_COMBO_COM_PORT, m_cmbCOM_Port);
	DDX_Control(pDX, IDC_COMBO_LPT_PORT, m_cmbLPT_Port);
	DDX_Control(pDX, IDC_COMBO_DENSITY, m_cmbDensity);
	DDX_Control(pDX, IDC_COMBO_SPEED, m_cmbSpeed);
}

BEGIN_MESSAGE_MAP(CSampleProgramDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_CONTROL_RANGE(BN_CLICKED, IDC_RADIO_SERIAL, IDC_RADIO_BLUETOOTH, OnBnClickedRadioIF)
	ON_EN_KILLFOCUS(IDC_EDIT_P_WIDTH, &CSampleProgramDlg::OnEnKillfocusEditPWidth)
	ON_EN_KILLFOCUS(IDC_EDIT_P_HEIGHT, &CSampleProgramDlg::OnEnKillfocusEditPHeight)
	ON_EN_KILLFOCUS(IDC_EDIT_MARGIN_X, &CSampleProgramDlg::OnEnKillfocusEditMarginX)
	ON_EN_KILLFOCUS(IDC_EDIT_MARGIN_Y, &CSampleProgramDlg::OnEnKillfocusEditMarginY)
	ON_BN_CLICKED(IDC_BUTTON_PRINT, &CSampleProgramDlg::OnBnClickedButtonPrint)
	ON_BN_CLICKED(IDC_BUTTON_STATUS, &CSampleProgramDlg::OnBnClickedButtonStatus)
END_MESSAGE_MAP()


// CSampleProgramDlg message handlers

BOOL CSampleProgramDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	InitControls();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSampleProgramDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSampleProgramDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSampleProgramDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CSampleProgramDlg::InitControls()
{
	// Interface
	((CButton*)GetDlgItem(IDC_RADIO_USB))->SetCheck(TRUE);
	EnableIFControls(INF_USB);

	// Communication setting
	m_cmbLPT_Port.SetCurSel(0);
	m_cmbCOM_Port.SetCurSel(0);
	m_cmbCOM_Baudrate.SetCurSel(4); // 115200
	m_cmbCOM_Databits.SetCurSel(1); // 8
	m_cmbCOM_Parity.SetCurSel(0);	// None;Odd;Even
	m_cmbCOM_Stopbits.SetCurSel(0); // 1

	m_Lan_IPAddr.SetAddress(192, 168, 1, 1);
	SetDlgItemText(IDC_EDIT_LAN_PORT, _T("9100"));

	CString strValue = _T("");

	// Speed 
	m_cmbSpeed.SetCurSel(0);
	// Density
	m_cmbDensity.SetCurSel(14 - 1);

	DOUBLE dbValue;
	// Paper width
	dbValue = 4 * 25.4;	// 4 inch
	strValue.Format(_T("%3.3f"), dbValue);
	SetDlgItemText(IDC_EDIT_P_WIDTH, strValue);
	// Paper height
	dbValue = 6 * 25.4; // 6 inch
	strValue.Format(_T("%3.3f"), dbValue);
	SetDlgItemText(IDC_EDIT_P_HEIGHT, strValue);
	// x margin 
	SetDlgItemText(IDC_EDIT_MARGIN_X, _T("0"));
	//  y margin
	SetDlgItemText(IDC_EDIT_MARGIN_Y, _T("0"));
	// Media type
	((CButton*)GetDlgItem(IDC_RADIO_MT_DT))->SetCheck(TRUE);
	// Sensor type
	((CButton*)GetDlgItem(IDC_RADIO_ST_GAP))->SetCheck(TRUE);
	// Print direction
	((CButton*)GetDlgItem(IDC_RADIO_PRINTDIR_TOP))->SetCheck(TRUE);
	// Operation Mode
	((CButton*)GetDlgItem(IDC_RADIO_TEAROFF))->SetCheck(TRUE);
	UpdateData(FALSE);
}

void CSampleProgramDlg::EnableIFControls(int nInterface)
{
	m_cmbLPT_Port.EnableWindow(nInterface == INF_PARALLEL);
	m_cmbCOM_Port.EnableWindow(nInterface == INF_SERIAL || nInterface == INF_BLUETOOTH);
	m_cmbCOM_Baudrate.EnableWindow(nInterface == INF_SERIAL);
	m_cmbCOM_Databits.EnableWindow(nInterface == INF_SERIAL);
	m_cmbCOM_Parity.EnableWindow(nInterface == INF_SERIAL);
	m_cmbCOM_Stopbits.EnableWindow(nInterface == INF_SERIAL);

	m_Lan_IPAddr.EnableWindow(nInterface == INF_ETHERNET);
	GetDlgItem(IDC_EDIT_LAN_PORT)->EnableWindow(nInterface == INF_ETHERNET);

	UpdateData(FALSE);
}

void CSampleProgramDlg::OnBnClickedRadioIF(UINT msg)
{
	UpdateData(TRUE);
	int nIF = INF_USB;
	
	if( ((CButton*)GetDlgItem(IDC_RADIO_SERIAL))->GetCheck() )
		nIF = INF_SERIAL;
	else if( ((CButton*)GetDlgItem(IDC_RADIO_PARALLEL))->GetCheck() )
		nIF = INF_PARALLEL;
	else if( ((CButton*)GetDlgItem(IDC_RADIO_USB))->GetCheck() )
		nIF = INF_USB;
	else if( ((CButton*)GetDlgItem(IDC_RADIO_LAN))->GetCheck() )
		nIF = INF_ETHERNET;
	else if( ((CButton*)GetDlgItem(IDC_RADIO_BLUETOOTH))->GetCheck() )
		nIF = INF_BLUETOOTH;

	EnableIFControls(nIF);
}

void CSampleProgramDlg::OnEnKillfocusEditPWidth()
{
	UpdateData(TRUE);

	DOUBLE dbValue;
	CString strValue = _T("");

	GetDlgItemText(IDC_EDIT_P_WIDTH, strValue);
	dbValue = atof(strValue);

	strValue.Format(_T("%3.3f"), dbValue);
	SetDlgItemText(IDC_EDIT_P_WIDTH, strValue);

	UpdateData(FALSE);
}

void CSampleProgramDlg::OnEnKillfocusEditPHeight()
{
	UpdateData(TRUE);

	DOUBLE dbValue;
	CString strValue = _T("");

	GetDlgItemText(IDC_EDIT_P_HEIGHT, strValue);
	dbValue = atof(strValue);

	strValue.Format(_T("%3.3f"), dbValue);
	SetDlgItemText(IDC_EDIT_P_HEIGHT, strValue);

	UpdateData(FALSE);
}

void CSampleProgramDlg::OnEnKillfocusEditMarginX()
{
	UpdateData(TRUE);

	DOUBLE dbValue;
	CString strValue = _T("");

	GetDlgItemText(IDC_EDIT_MARGIN_X, strValue);
	dbValue = atof(strValue);

	strValue.Format(_T("%3.3f"), dbValue);
	SetDlgItemText(IDC_EDIT_MARGIN_X, strValue);

	UpdateData(FALSE);
}

void CSampleProgramDlg::OnEnKillfocusEditMarginY()
{
	UpdateData(TRUE);

	DOUBLE dbValue;
	CString strValue = _T("");

	GetDlgItemText(IDC_EDIT_MARGIN_Y, strValue);
	dbValue = atof(strValue);

	strValue.Format(_T("%3.3f"), dbValue);
	SetDlgItemText(IDC_EDIT_MARGIN_Y, strValue);

	UpdateData(FALSE);
}

BOOL CSampleProgramDlg::Connect()
{
	UpdateData(TRUE);

	BOOL bRetVal = FALSE;
	CString strPort = "";
	int nBaudrate, nDatabits, nParity, nStopbits;
	int nInterface = INF_USB;

	if( ((CButton*)GetDlgItem(IDC_RADIO_SERIAL))->GetCheck() )
		nInterface = INF_SERIAL;
	else if( ((CButton*)GetDlgItem(IDC_RADIO_PARALLEL))->GetCheck() )
		nInterface = INF_PARALLEL;
	else if( ((CButton*)GetDlgItem(IDC_RADIO_USB))->GetCheck() )
		nInterface = INF_USB;
	else if( ((CButton*)GetDlgItem(IDC_RADIO_BLUETOOTH))->GetCheck() )
		nInterface = INF_BLUETOOTH;
	else if( ((CButton*)GetDlgItem(IDC_RADIO_LAN))->GetCheck() )
		nInterface = INF_WIFI;

	nBaudrate	= GetDlgItemInt(IDC_COMBO_COM_BAUDRATE);
	nDatabits	= GetDlgItemInt(IDC_COMBO_COM_DATABITS);
	nParity		= m_cmbCOM_Parity.GetCurSel();		// NOPARITY, ODDPARITY, EVENPARITY
	nStopbits	= m_cmbCOM_Stopbits.GetCurSel();	// ONESTOPBIT, ONE5STOPBITS, TWOSTOPBITS

	switch(nInterface)
	{
	case INF_SERIAL:
	case INF_BLUETOOTH:
		GetDlgItemText(IDC_COMBO_COM_PORT, strPort);
		break;
	case INF_PARALLEL:
		GetDlgItemText(IDC_COMBO_LPT_PORT, strPort);
		break;
	case INF_USB:
		break;
	case INF_ETHERNET:
	case INF_WIFI:
		{
			BYTE btLanIp[4] = {NULL, };
			m_Lan_IPAddr.GetAddress(btLanIp[0], btLanIp[1], btLanIp[2], btLanIp[3]); 
			strPort.Format("%d.%d.%d.%d",btLanIp[0], btLanIp[1], btLanIp[2], btLanIp[3]);
			nBaudrate = GetDlgItemInt(IDC_EDIT_LAN_PORT);
		}
		break;
	}

	int nStatus = ConnectPrinter(nInterface, strPort, nBaudrate, nDatabits, nParity, nStopbits, 0 /*Flowcontrol: Hardware */);

	if( nStatus != ERROR_SUCCESS )
	{
		DisconnectPrinter();
		CString strStatus = GetStatusMsg(nStatus);
		MessageBox(strStatus, NULL, MB_OK|MB_ICONERROR);
		return FALSE;
	}
	return TRUE;
}

void CSampleProgramDlg::OnBnClickedButtonPrint()
{
	if(!Connect())
		return;
	
	int multiplier = 1;
	// 203 DPI : 1mm is about 7.99 dots
	// 300 DPI : 1mm is about 11.81 dots
	// 600 DPI : 1mm is about 23.62 dots
	int resolution = GetPrinterDPI();
	int dotsPer1mm = (int)((float)GetPrinterDPI() / 25.4f);
	if (resolution >= 600)
		multiplier = 3;

	SendPrinterSettingCommand();

	// Prints string using TrueFont
	//  P1 : Horizontal position (X) [dot]
	//  P2 : Vertical position (Y) [dot]
	//  P3 : Font Name
	//  P4 : Font Size
	//  P5 : Rotation : (0 : 0 degree , 1 : 90 degree, 2 : 180 degree, 3 : 270 degree)
	//  P6 : Italic
	//  P7 : Bold
	//  P8 : Underline
	//  P9 : RLE (Run-length encoding)
	//PrintTrueFontLib(2 * dotsPer1mm, 5 * dotsPer1mm, "Arial", 14, 0, true, true, false, "Sample Label-1", false);
	PrintTrueFont(2 * dotsPer1mm, 5 * dotsPer1mm, "Arial", 14, 0, true, true, false, "Sample Label-1", false);

	//	Draw Lines
	PrintBlock(1 * dotsPer1mm, 10 * dotsPer1mm, 71 * dotsPer1mm, 11 * dotsPer1mm, LINE_OVER_WRITING, 0);

	//Print string using Vector Font
	//  P1 : Horizontal position (X) [dot]
	//  P2 : Vertical position (Y) [dot]
	//  P3 : Font selection
	//        U: ASCII (1Byte code)
	//        K: KS5601 (2Byte code)
	//        B: BIG5 (2Byte code)
	//        G: GB2312 (2Byte code)
	//        J: Shift-JIS (2Byte code)
	// P4  : Font width (W)[dot]
	// P5  : Font height (H)[dot]
	// P6  : Right-side character spacing [dot], Plus (+)/Minus (-) option can be used. Ex) 5, +3, -10	
	// P7  : Bold
	// P8  : Reverse printing
	// P9  : Text style  (N : Normal, I : Italic)
	// P10 : Rotation (0 ~ 3)
	// P11 : Text Alignment
	//        L: Left
	//        R: Right
	//        C: Center
	// P12 : Text string write direction (0 : left to right, 1 : right to left)
	// P13 : data to print
	//PrintVectorFont(22, 65, "U", 34, 34, "0", false, false, false, ROTATE_0, "L", LEFTTORIGHT, "Sample Label-2");

	PrintDeviceFont(2 * dotsPer1mm, 12 * dotsPer1mm, ENG_24X38, multiplier, multiplier, ROTATE_0, false, "SHIP TO:");
	PrintDeviceFont(2 * dotsPer1mm, 17 * dotsPer1mm, ENG_19X30, multiplier, multiplier, ROTATE_0, true, "SATO");
	PrintDeviceFont(2 * dotsPer1mm, 21 * dotsPer1mm, ENG_16X25, multiplier, multiplier, ROTATE_0, false, "7th FL, MiraeAsset Venture Tower,");

	PrintDeviceFont(2 * dotsPer1mm, 24 * dotsPer1mm, ENG_16X25, multiplier, multiplier, ROTATE_0, false, "685, Sampyeong-dong, Bundang-gu,");
	PrintDeviceFont(2 * dotsPer1mm, 27 * dotsPer1mm, ENG_16X25, multiplier, multiplier, ROTATE_0, false, "Seongnam-si, Gyeonggi-do,");

	PrintDeviceFont(3 * dotsPer1mm, 36 * dotsPer1mm, ENG_12X20, multiplier, multiplier, ROTATE_0, false, "POSTAL CODE");
	Print1DBarcode(3 * dotsPer1mm, 40 * dotsPer1mm, CODE39, 4 * multiplier, 6 * multiplier, 48 * multiplier, ROTATE_0, HRI_NOT_PRINT, "1234567890");

	PrintDeviceFont(3 * dotsPer1mm, 50 * dotsPer1mm, ENG_12X20, multiplier, multiplier, ROTATE_0, false, "AWB:");
	Print1DBarcode(3 * dotsPer1mm, 53 * dotsPer1mm, CODE93, 4 * multiplier, 8 * multiplier, 90 * multiplier, ROTATE_0, HRI_NOT_PRINT, "8741493121");

	PrintDeviceFont(4 * dotsPer1mm, 69 * dotsPer1mm, ENG_12X20, multiplier, multiplier, ROTATE_0, false, "WEIGHT:");
	PrintDeviceFont(29 * dotsPer1mm, 69 * dotsPer1mm, ENG_12X20, multiplier, multiplier, ROTATE_0, false, "DELIVERY NO:");
	PrintDeviceFont(53 * dotsPer1mm, 69 * dotsPer1mm, ENG_12X20, multiplier, multiplier, ROTATE_0, false, "DESTINATION");

	PrintDeviceFont(3 * dotsPer1mm, 73 * dotsPer1mm, ENG_32X50, multiplier, multiplier, ROTATE_0, true, "30Kg");
	PrintDeviceFont(26 * dotsPer1mm, 73 * dotsPer1mm, ENG_32X50, multiplier, multiplier, ROTATE_0, true, "425518");
	PrintDeviceFont(55 * dotsPer1mm, 73 * dotsPer1mm, ENG_32X50, multiplier, multiplier, ROTATE_0, true, "ICN");

	// Prints a DATAMATRIX
	int xString = (35 * dotsPer1mm);
	int yString = (83 * dotsPer1mm);
	CString DataMatrix_data = "Label Printer, This is for test.";
	PrintDataMatrix(xString, yString, DATAMATRIX_SIZE_4, false, ROTATE_0, DataMatrix_data);

	// Prints a QRCode
	//  P1 : Horizontal position (X) [dot]
	//  P2 : Vertical position (Y) [dot]
	//  P3 : MODEL selection (1, 2)
	//  P4 : ECC Level (1 ~ 4)
	//  P5 : Size of QRCode (1 ~ 8)
	//  P6 : Rotation (0 ~ 3)
	//  P7 : data to print
	CString QRCode_data = "QRCode sample test 123";
	PrintQRCode(50 * dotsPer1mm, 83 * dotsPer1mm, QRMODEL_2, QRECCLEVEL_M, QRSIZE_4, ROTATE_0, QRCode_data);

	// Prints a PDF417
	//  P1 : Horizontal position (X) [dot]
	//  P2 : Vertical position (Y) [dot]
	//  P3 : Maximum Row Count : 3 ~ 90
	//  P4 : Maximum Column Count : 1 ~ 90
	//  P5 : Error Correction Level
	//  P6 : Data compression method
	//  P7 : HRI
	//  P8 : Barcode Origin Point
	//  P9 : Module Width : 2 ~ 9
	//  P10 : Module Height : 4 ~ 99
	//  P11 : Rotation (0 ~ 3)
	//  P12 : data to print
	xString = (1 * dotsPer1mm);
	yString = (114 * dotsPer1mm);
	CString PDF417_data = "Label Printer, This is for test.";
	PrintPDF417(xString, yString, 8, 8, 0, 0, false, 1, 3 * multiplier, 14 * multiplier, ROTATE_0, PDF417_data);

	// Draw BOX (Fill color is black)
	PrintBlock(1 * dotsPer1mm, 80 * dotsPer1mm, 71 * dotsPer1mm, 112 * dotsPer1mm, BOX, 4);
	//PrintCircle(10, 1055, 3, 2);

	// Print Image
	PrintBitmapFile(1 * dotsPer1mm, 122 * dotsPer1mm, "SATO.bmp", DITHER_1, false);

	//	Print Command
	Prints(1, 1);

	// Disconnect printer
	DisconnectPrinter();
}

void CSampleProgramDlg::SendPrinterSettingCommand()
{
	UpdateData(TRUE);

	CString strValue = _T("");
	BOOL bAutoCut			= FALSE;
	BOOL bRewinder			= FALSE;
	BOOL bReverseFeeding	= TRUE;
	int nPaper_Width		= 0;
	int nPaper_Height		= 0;
	int nMarginX			= 0;
	int nMarginY			= 0;
	int nDensity			= 14;
	int nSpeed				= PRINTER_SETTING_SPEED;
	int nSensorType			= GAP; 
	int nPrintDirection		= TOP2BOTTOM;


	int dotsPer1mm = 8;	// mm to dot
	// 203 DPI : 1mm is about 7.99 dots
	// 300 DPI : 1mm is about 11.81 dots
	// 600 DPI : 1mm is about 23.62 dots
	int nPrtDPI = (int)((float)GetPrinterDPI() / 25.4f + 0.5f);

	GetDlgItemText(IDC_EDIT_P_WIDTH, strValue);
	nPaper_Width = (int)((atof(strValue)) * dotsPer1mm);

	GetDlgItemText(IDC_EDIT_P_HEIGHT, strValue);
	nPaper_Height = (int)((atof(strValue)) * dotsPer1mm);

	GetDlgItemText(IDC_EDIT_MARGIN_X, strValue);
	nMarginX = (int)((atof(strValue)) * dotsPer1mm);

	GetDlgItemText(IDC_EDIT_MARGIN_Y, strValue);
	nMarginY = (int)((atof(strValue)) * dotsPer1mm);

	nDensity	= GetDlgItemInt(IDC_COMBO_DENSITY);
	if(m_cmbSpeed.GetCurSel() != 0)
		nSpeed = GetDlgItemInt(IDC_COMBO_SPEED);

	if(((CButton*)GetDlgItem(IDC_RADIO_ST_GAP))->GetCheck()) 
		nSensorType = GAP;
	else if(((CButton*)GetDlgItem(IDC_RADIO_ST_BM))->GetCheck()) 
		nSensorType = BLACKMARK;
	else 
		nSensorType = CONTINUOUS;

	if(((CButton*)GetDlgItem(IDC_RADIO_PRINTDIR_BOTTOM))->GetCheck())
		nPrintDirection = BOTTOM2TOP;

	bAutoCut = ((CButton*)GetDlgItem(IDC_RADIO_CUT))->GetCheck();
	bRewinder = ((CButton*)GetDlgItem(IDC_RADIO_REWIND))->GetCheck();

	//Clear Buffer of Printer
	ClearBuffer();
	if(bRewinder){
		PrintDirect("RWDy", TRUE);
	}

	// Select international character set and code table.To
	SetCharacterset(ICS_USA, FCP_CP1252);

	// Set Label and Printer
	SetConfigOfPrinter(nSpeed, nDensity, nPrintDirection, bAutoCut, 1, TRUE);

    /* 
		1 Inch : 25.4mm
		1 mm   :  7.99 Dots (PV3, PV4) 
	*/
	SetPaper(nMarginX, nMarginY, nPaper_Width, nPaper_Height, nSensorType, 0, dotsPer1mm*2); // 4 inch (Width) * 6 inch (Hiehgt)
	
	// Direct thermal or Thermal transfer
	if(((CButton*)GetDlgItem(IDC_RADIO_MT_TT))->GetCheck())
		PrintDirect("STt", TRUE);
	else
		PrintDirect("STd", TRUE);

}

void CSampleProgramDlg::OnBnClickedButtonStatus()
{
	if(!Connect())
		return;

	int nStatus = CheckStatus();
	CString strStatus = GetStatusMsg(nStatus);

	if( nStatus == ERROR_SUCCESS )
		AfxMessageBox(strStatus, MB_OK|MB_ICONINFORMATION);
	else
		AfxMessageBox(strStatus, MB_OK|MB_ICONERROR);

	DisconnectPrinter();
}

CString CSampleProgramDlg::GetStatusMsg(int nStatus)
{
	CString errMsg = "";
	switch (nStatus)
	{
	case ERR_CODE_NO_ERROR:				errMsg = "No Error";									break;
	case ERR_CODE_PAPER_EMPTY:			errMsg = "Paper Empty";									break;
	case ERR_CODE_COVER_OPEN:			errMsg = "Cover Open";									break;
	case ERR_CODE_MOTOR_OVER_HEAT:		errMsg = "Motor overheat";								break;
	case ERR_CODE_TPH_OVER_HEAT:		errMsg = "TPH overheat";								break;
	case ERR_CODE_AUTO_SENSING:			errMsg = "Auto-sensing failure";						break;
	case ERR_CODE_BOARD_OVER_HEAT:		errMsg = "Board overheat";								break;
	case ERR_CODE_WAIT_FOR_LABEL_TAKEN:	errMsg = "Wait for paper to be taken";					break;
	case ERR_CODE_PAUSED_LABEL:			errMsg = "Issued label is paused in peeler unit";		break;
	case ERR_CODE_PRINTING_LABEL:		errMsg = "Printing label in image buffer";				break;
	case ERR_CODE_BUILDING_LABEL:		errMsg = "Building label to be printed in the buffer";	break;
	case ERR_CODE_UNABLE_CONNECT:		errMsg = "Unable to connect the printer";				break;
	default:							errMsg = "Unknown error";								break;
	}
	return errMsg;
}